%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 4;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}

%bcond_without check

%global crate hyperfine

Name:           rust-hyperfine
Version:        1.18.0
Release:    1%{?dist}
Summary:        Command-line benchmarking tool

License:        MIT OR Apache-2.0
URL:            https://crates.io/crates/hyperfine
Source0:         %{crates_source}
Patch:          hyperfine-fix-metadata-auto.diff
Patch:          hyperfine-fix-metadata.diff

BuildRequires:  cargo-rpm-macros >= 24

%global _description %{expand:
A command-line benchmarking tool.}

%description %{_description}

%package     -n %{crate}
Summary:        %{summary}
License:        MIT AND MPL-2.0 AND (Apache-2.0 OR BSL-1.0) AND (Apache-2.0 OR MIT) AND (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND (Unlicense OR MIT)

%description -n %{crate} %{_description}

%files       -n %{crate}
%license LICENSE-APACHE
%license LICENSE-MIT
%license LICENSE.dependencies
%doc CHANGELOG.md
%doc README.md
%{_bindir}/hyperfine
%{_mandir}/man1/hyperfine.1*
%{bash_completions_dir}/hyperfine.bash
%{fish_completions_dir}/hyperfine.fish
%{zsh_completions_dir}/_hyperfine

%prep
%autosetup -n %{crate}-%{version} -p1
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires

%build
%cargo_build
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies

%install
%cargo_install
install -Dpm 0644 doc/hyperfine.1 -t %{buildroot}/%{_mandir}/man1
install -Dpm 0644 target/release/build/%{crate}-*/out/hyperfine.bash \
    -t %{buildroot}/%{bash_completions_dir}
install -Dpm 0644 target/release/build/%{crate}-*/out/hyperfine.fish \
    -t %{buildroot}/%{fish_completions_dir}
install -Dpm 0644 target/release/build/%{crate}-*/out/_hyperfine \
    -t %{buildroot}/%{zsh_completions_dir}

%if %{with check}
%check
%cargo_test
%endif

%changelog
* Tue Jun 18 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.18.0-1
- initial build
